#include "global.hh"
#include "Cfile.hh"
#include "Cdata_reader.hh"

#include "user.hh"

int Cdata_reader::read_in_one_line(Cfile* file)
{
  /* read one line */
  if(file->read_line(m_buf, sizeof(m_buf)) == END_OF_FILE){
    return END_OF_FILE;
  }

  /* check comment */
  if(check_comment() == COMMENT){
    return COMMENT;
  }

  //  printf("%s",m_buf);

  /* inport data to int buf */
  USER_SSCANF(m_number_of_data, m_buf, m_data_buf);/* !!user defined function!! */

  //  printf("%x %x\n",m_data_buf[0], m_data_buf[1]);

  /* check scaned data number */
  if(m_number_of_data != NUMBER_OF_DATA){
    printf("\n scaned number and number_of_data is not consistent!!\n\n");
    return ERROR;
  }

  /* convert data(2byte or 4byte) to data_t(2byte) */
  if(convert_data_to_data_t(DATA_SIZE) == ERROR){
    printf("error@Cdata_reader::convert_data_to_data_t\n");
    return ERROR;
  }

  //  printf("%x %x %x %x\n",m_data[0], m_data[1], m_data[2], m_data[3]);

  /* count number of word */
  if(count_number_of_word(DATA_SIZE) == ERROR){
    printf("error@Cdata_reader::count nuber of word\n");
    return ERROR;
  }

  return OK;
}

int Cdata_reader::get_number_of_word()
{
  return m_number_of_word;
}

int Cdata_reader::get_data(data_t& data, int i)
{
  if(i < 0 || m_number_of_word <= i ){
    data = 0;
    printf("cannot access to m_data[%d]\n", i);
    return ERROR;
  }
  data = m_data[i];
  return OK;
}

int Cdata_reader::check_comment()
{
  char comment[2];
  comment[0] = 0;
  comment[1] = 0;

  sscanf(m_buf, "%c%c", &comment[0], &comment[1]);
  if(comment[0] == '#' ||
     comment[0] == 'c' ||
     comment[0] == '%' ||
     comment[0] == '\n' ||
     (comment[0] == '/' && comment[1] == '/')){
    return COMMENT;
  }
}

int Cdata_reader::count_number_of_word(size_t size)
{
  if(size == (size_t)4){
    m_number_of_word = 2 * m_number_of_data;
  }else if(size == (size_t)2){
    m_number_of_word = m_number_of_data;      
  }else{
    printf("input data_size is wrong\n");
    return ERROR;
  }
}

int Cdata_reader::convert_data_to_data_t(size_t size)
{
  if(size == (size_t)4){
    /* decompose 4byte word to 2byte(it doesn't matter of int or float) */  
    /* m_data_buf[1] = 0x000000001 -> m_data[0] = 0x0001, m_data[1] = 0x0000 */
    for(int i = 0; i < m_number_of_data; ++i){
      char* pt = (char*)&m_data_buf[i];
      memcpy(&m_data[2*i], pt, 2);
      memcpy(&m_data[2*i+1], pt+2, 2);
    }
  }else if(size == (size_t)2){
    /* only cast data to data_t */
    for(int i = 0; i < m_number_of_data; ++i){
      /* check that imported number is smaller than data_t */
      if(((m_data_buf[i] & 0x11110000) != 0x00000000) &&
	 ((m_data_buf[i] & 0x11110000) != 0x11110000)){
	printf("input data is too large or small for short\n");
	return ERROR;
      }
      m_data[i] = (data_t)m_data_buf[i];
    }
  }else{
    printf("input data_size is wrong\n");
    return ERROR;
  }
  return OK;
}
